// import the core of the framework:
import 'package:objd/core.dart';

class CustomCommand extends Widget {
  //Command with permission

  //variables
  String command;
  List<String> permissions;
  List<Widget> children;
  bool addToLoad = true;
  int from;

  List<Entity> entityScore = [];
  List<Entity> entity = [];

  CustomCommand(this.command, this.permissions,
      {this.children, this.addToLoad = true, this.from = 1}) {
    for (var i = 0; i < permissions.length; i++) {
      entityScore.add(
        Entity.All(
          tags: [permissions[i]],
          scores: [
            Score(Entity.Self(), command).matchesRange(
              Range(from: from),
            ),
          ],
        ),
      );
    }
    for (var i = 0; i < permissions.length; i++) {
      entity.add(
        Entity.All(
          tags: [permissions[i]],
        ),
      );
    }
  }
  CustomCommand.Self(this.command,
      {this.children, this.addToLoad = true, this.from = 1}) {
    entityScore.add(
      Entity.Self(
        scores: [
          Score(Entity.Self(), command).matchesRange(
            Range(from: from),
          ),
        ],
      ),
    );
    entity.add(
      Entity.Self(),
    );
  }
  CustomCommand.All(this.command,
      {this.children, this.addToLoad = true, this.from = 1}) {
    entityScore.add(
      Entity.All(
        scores: [
          Score(Entity.Self(), command).matchesRange(
            Range(from: from),
          ),
        ],
      ),
    );
    entity.add(
      Entity.All(),
    );
  }

  @override
  Widget generate(Context context) {
    return For.of([
      if (addToLoad) Scoreboard(command, addIntoLoad: true, type: "trigger"),
      For(
        to: entity.length - 1,
        create: (int i) {
          return For.of([
            Comment.Seperate(),
            Execute.as(entityScore[i], children: children),
            Execute.as(
              entityScore[i],
              children: [
                Comment.Seperate(),
                Comment("Reset Score"),
                Execute.as(
                  Entity.All(
                    scores: [
                      Score(Entity.Self(), command).matchesRange(
                        Range(from: from),
                      ),
                    ],
                  ),
                  children: [
                    Score(Entity.Self(), command).reset(),
                  ],
                ),
              ],
            ),
          ]);
        },
      ),
      Comment.Seperate(),
      //No permission msg
      Execute.as(
        Entity.All(
          scores: [
            Score(Entity.Self(), command).matchesRange(
              Range(from: from),
            ),
          ],
        ),
        children: [
          Tellraw(
            Entity.Self(),
            show: [
              TextComponent(
                "Sorry, you don't have enough permissions.",
                color: Color.Red,
              ),
            ],
          ),
          Score(Entity.Self(), command).reset(),
        ],
      ),
      Comment.Seperate(),
      //Enable
      Execute.as(
        Entity.All(),
        children: [
          Command('/scoreboard players enable ' +
              Entity.Self().toString() +
              ' ' +
              command),
        ],
      ),
    ]);
  }
}
