import 'package:objd/core.dart';

class DetectBlock extends Widget {
  Block _block;
  var block;
  String tag;

  DetectBlock(this._block, {this.tag = "objd_detect"}) {
    block = _block.toString().substring(10);
  }

  @override
  generate(Context context) {
    return For.of([
      //Base Stuff
      Scoreboard("Detect"),

      //Block
      Scoreboard(
        "placed" + block,
        type: "minecraft.used:minecraft." + block,
      ),

      //MAIN
      Comment("Summon all ARC to detect where the block is"),
      Execute.at(
        Entity.All(
          scores: [
            Score(
              Entity.Self(),
              "Detect",
            ).matches(1),
          ],
        ),
        children: [
          For(
            from: -6,
            to: 6,
            create: (int i) {
              return For.of([
                For(
                  from: -6,
                  to: 6,
                  create: (int j) {
                    return AreaEffectCloud.persistent(
                      Location.rel(
                        x: i.toDouble(),
                        y: -6,
                        z: j.toDouble(),
                      ),
                      tags: ["Detect"],
                    );
                  },
                ),
              ]);
            },
          ),
        ],
      ),
      Score(
        Entity.All(
          scores: [
            Score(
              Entity.Self(),
              "Detect",
            ).matchesRange(
              Range(from: 1),
            ),
          ],
        ),
        "Detect",
      ).add(1),

      Comment("Place the ARC with a custom tag on the selected block"),
      Execute.asat(
        Entity(
          tags: ["Detect"],
        ),
        children: [
          Tp(
            Entity.Self(),
            to: Location.rel(y: 1),
          ),
          If(
            Condition.and([
              Condition.block(
                Location.here(),
                block: _block,
              ),
            ]),
            then: [
              Summon(
                Entities.leash_knot,
                tags: [block + "Tmp"],
              ),
            ],
          ),
          Execute(
            at: Entity(
              tags: [block + "Tmp"],
            ),
            unless: Condition.entity(
              Entity(
                tags: [
                  block,
                ],
                distance: Range(to: 1),
              ),
            ),
            children: [
              AreaEffectCloud.persistent(
                Location.rel(y: -0.5),
                tags: [
                  block,
                  tag,
                ],
              ),
            ],
          ),
        ],
      ),
      Execute.as(
        Entity(
          scores: [
            Score(Entity.Self(), "Detect").matchesRange(
              Range(from: 18),
            ),
          ],
        ),
        children: [
          Kill(
            Entity(
              tags: ["Detect"],
            ),
          ),
          Score(Entity.Self(), "Detect").set(0),
        ],
      ),

      Comment("Detect " + block),
      Score(
        Entity.All(
          scores: [
            Score(
              Entity.Self(),
              "placed" + block,
            ).matchesRange(
              Range(from: 1),
            ),
          ],
        ),
        "Detect",
      ).add(1),
      Score(
        Entity.All(),
        "placed" + block,
      ).set(0),
      Execute(
        as: Entity(
          tags: [
            block,
          ],
        ),
        at: Entity.Self(),
        If: Condition.block(Location.here(), block: Blocks.air),
        children: [
          Kill(
            Entity.Self(),
          ),
        ],
      ),
    ]);
  }
}
