import 'package:objd/core.dart';

class JoinEvent extends Widget {
  String score;
  String tag;
  List<Widget> content;


  JoinEvent(this.score, this.tag, {this.content});

  @override
  generate(Context context) {
    return For.of([
      //SCORE
      Scoreboard(
        score,
        type: "minecraft.custom:minecraft.leave_game",
      ),

      //Check for new Players
      Execute.as(Entity.All(), children: [
        If.not(
          Condition.score(
            Score(Entity.Self(), score)
            .matchesRange(Range(from: 1))
          ), 
          then: [
            Score(Entity.Self(), score).set(0)
          ]
        ),
        ],
      ),
      Score(Entity.All(scores: [Score(Entity.Self(), score).matchesRange(Range(from: 3))]), score).set(0),
      Score(Entity.All(scores: [Score(Entity.Self(), score).matchesRange(Range(to: 0))]), score).set(1),
      Command('/execute as @a[scores={' + score + '=1}] run tag @s add ' + tag),

      Execute.asat(Entity.All(tags:["lsNewJoinedPlayer"]), children: 
          content
      ),

      //LAST THING
      Score(Entity.All(tags: ["lsNewJoinedPlayer"]), "lsLobbyLeft").set(2),
      Entity.All(tags: ["lsNewJoinedPlayer"]).removeTag("lsNewJoinedPlayer"),
    ]);
  }

}