import 'package:objd/core.dart';

class LeaveEvent extends Widget {
  String score;
  int from;
  List<Widget> content;

  LeaveEvent(this.score, {this.content, this.from = 1});

  @override
  generate(Context context) {
    return For.of([
      //SCORE
      Scoreboard(
        score,
        type: "minecraft.custom:minecraft.leave_game",
      ),

      //MAIN
      Execute(
        as: Entity.All(
          scores: [
            Score(
              Entity.Self(),
              score,
            ).matchesRange(
              Range(from: from),
            ),
          ],
        ),
        at: Entity.Self(),
        children: content,
      ),

      Score(
        Entity.All(
          scores: [
            Score(
              Entity.Self(),
              score,
            ).matchesRange(
              Range(from: from),
            ),
          ],
        ),
        score,
      ).reset(),
    ]);
  }
}
